//ClientRequestHandler.h

#ifndef __CCLIENTREQUESTHANDLER_H
#define __CCLIENTREQUESTHANDLER_H

#include <e32base.h>
#include "checkedactive.h"
#include "ContextClientSession.h"
#include "RequestHandlerObserver.h"

class CClientRequestHandler : public CCheckedActive
{

public:
	IMPORT_C static CClientRequestHandler * NewL(MRequestHandlerObserver& aObserver) ;
	IMPORT_C static CClientRequestHandler * NewLC(MRequestHandlerObserver& aObserver) ;
	IMPORT_C ~CClientRequestHandler();

	//connect to ContextServer.exe via RPC
	IMPORT_C TInt ConnectToContextServer();

	IMPORT_C TPtrC GetPresenceInfo() const;

	// Requests to be used by context_log
	IMPORT_C void ConnectToPresenceServer(TDesC & username, TDesC & password, TDesC & server, TUint32 accessPointId);
	IMPORT_C void SuspendConnectionWithPresenceServer();
	IMPORT_C void ResumeConnectionWithPresenceServer();
	IMPORT_C void TerminateContextServer();
	IMPORT_C void UpdateUserPresence(TDesC & info);

	// Requests to be used by ContextBook
	IMPORT_C void RequestPresenceInfoNotification();

	IMPORT_C void CancelRequest();

protected: // from CCheckedActive
	void CheckedRunL();
	void DoCancel();

private:
	void ConstructL();
	CClientRequestHandler(MRequestHandlerObserver& aObserver);

private: // data
    
    	enum TPhase
	{
      		EPhaseIdle,
        	EPhaseWaitingForPresenceInfo,
		EPhaseWaitingForConnectionToPresenceServer,
		EPhaseWaitingForDisconnectionFromPresenceServer,
		EPhaseWaitingForServerToTerminate,
		EPhaseUpdatingUserInfo,
		EPhaseResumingConnection,
		EPhaseSuspendingConnection
	};

	TPhase current_state;		
    	RContextClientSession  		iSession;
	TBuf<500>			contact;
	TBuf<500>			presenceInfo;
  	MRequestHandlerObserver & 	iObserver;
};

#endif