#ifndef SETTINGS_H_INCLUDED
#define SETTINGS_H_INCLUDED 1

#include "db.h"
#include "app_context.h"
#include "symbian_tree.h"

class CSettings : public MContextBase, public MSettings {
public:
	IMPORT_C static CSettings* NewL(MApp_context& Context, bool OwnedByContext=false, const TDesC& SettingName=TPtrC(0,0));
	~CSettings();
private:
	virtual bool GetSettingL(TInt Setting, TDes& Value);
	virtual bool GetSettingL(TInt Setting, TInt& Value);
	virtual bool GetSettingL(TInt Setting, TTime& Value);
	// virtual bool GetSettingL(TInt Setting, TBool& Value); TBool is typedeffed to int
	virtual void WriteSettingL(TInt Setting, const TDesC& Value);
	virtual void WriteSettingL(TInt Setting, const TInt& Value);
	virtual void WriteSettingL(TInt Setting, const TTime& Value);
	// virtual void WriteSettingL(TInt Setting, const TBool& Value); TBool is typedeffed to int
	virtual void NotifyOnChange(TInt Setting, MSettingListener* Listener);
	virtual void CancelNotifyOnChange(TInt Setting, MSettingListener* Listener);

	CSettings(MApp_context& Context, bool OwnedByContext);
	void ConstructL(const TDesC& SettingName);

	void NotifyOfChange(TInt Setting);

	CDb *iDb;
	CSingleColDb<TInt> *iIntStore;
	CSingleColDb<TTime> *iTimeStore;
	CSingleColDb<TDesC, TDes> *iDesStore;
	CGenericIntMap*	iListeners;
};

#endif
