#include "checkedactive.h"
#include "app_context.h"

EXPORT_C CCheckedActive::~CCheckedActive()
{
}

EXPORT_C CCheckedActive::CCheckedActive(TInt aPriority, const TDesC& Name) : CActive(aPriority)
{
	iName=Name.Left(40);
}

EXPORT_C TInt CCheckedActive::RunError(TInt aError)
{

	TInt ret=CheckedRunError(aError);
	
	if (ret!=KErrNone) {
		MApp_context* c=MApp_context::Static();
		if (c) {
			HBufC* stack=0;
			TRAPD(err, stack=HBufC::NewL( (c->CallStack().iCount+1)*101));
			if (err==KErrNone) {
				CleanupStack::PushL(stack);
				stack->Des().Append(iName);
				stack->Des().Append(_L(":"));
				CCallStack::Node* i=c->CallStack().iFirst;
				while (i) {
					stack->Des().Append(i->Item);
					stack->Des().Append(_L("|"));
					i=i->Next;
				}
				c->ReportActiveError(*stack,
					_L("Active Object Run Error"), ret);
				c->CallStack().reset();
				CleanupStack::PopAndDestroy(); // stack
			} else {
				c->ReportActiveError(iName,
					_L("Active Object Run Error"), ret);
			}
		}
	}
	return ret;
}

EXPORT_C void CCheckedActive::SetActive()
{
	if (iStatus!=KRequestPending) {
		TInt x;
		x=1;
	}
	CActive::SetActive();
}

EXPORT_C TInt CCheckedActive::CheckedRunError(TInt aError)
{
	return aError;
}

EXPORT_C void CCheckedActive::RunL()
{
	MApp_context* c=MApp_context::Static();
	if (c) {
		c->CallStack().reset();
	}
	CheckedRunL();
	if (c) {
		c->CallStack().reset();
	}
}