#include "store.h"

CReclaimManager::CReclaimManager()
{
}

void CReclaimManager::ConstructL()
{
	iList=CList<MReclaimable*>::NewL();
}

CReclaimManager* CReclaimManager::NewL()
{
	auto_ptr<CReclaimManager> ret(new (ELeave) CReclaimManager);
	ret->ConstructL();
	return ret.release();
}

void CReclaimManager::AddManagedL(MReclaimable* Managed)
{
	iList->AppendL(Managed);
	Managed->SetCurrentStamp(iCurrentStamp);
}

CReclaimManager::~CReclaimManager()
{
	delete iList;
}

void CReclaimManager::SetTimeStamp(uint16 Stamp)
{
	iCurrentStamp=Stamp;
	CList<MReclaimable*>::Node* i=iList->iFirst;
	while (i) {
		i->Item->SetCurrentStamp(Stamp);
		i=i->Next;
	}
}

void CReclaimManager::TriggerReclaimL(uint16 Upto)
{
	CList<MReclaimable*>::Node* i=iList->iFirst;
	while (i) {
		i->Item->ReclaimL(Upto);
		i=i->Next;
	}
}
