//CContextServerSession.h
#ifndef __CCONTEXTSERVERSESSION__
#define __CCONTEXTSERVERSESSION__

#include <e32base.h>
#include "ContextServer.h"

class CContextServerSession : public CSession
{

public: 
	static CContextServerSession* NewL(RThread& aClient, CContextServer& aServer);
	static CContextServerSession* NewLC(RThread& aClient, CContextServer& aServer);
	~CContextServerSession();
	
	void ServiceL(const RMessage& aMessage);

	void SendPresenceInfo(TDesC & presenceInfo);

private:
	CContextServerSession(RThread& aClient, CContextServer& aServer);
	void ConstructL() ;
	void PanicClient(TInt aPanic) const;

	void ConnectToPresenceServer(const RMessage & aMessage);
	void DisconnectFromPresenceServer(const RMessage & aMessage);
	void TerminateContextServer(const RMessage & aMessage);
	void HandleRequestPresenceInfo(const RMessage& aMessage);
	void HandleRequestPresenceNotification(const RMessage & aMessage);
	void UpdateUserPresence(const RMessage & aMessage);
	void SuspendConnection(const RMessage & aMessage);
	void ResumeConnection(const RMessage & aMessage);

private: 
	
	RMessage            iMessage;
	CContextServer&     iServer;
};

#endif

