#if !defined(DISCOVER_H_INCLUDED)

#define DISCOVER_H_INCLUDED

#include <e32base.h>
#include <f32file.h>
#include <e32std.h>

#include "log_base_impl.h"

#include <es_sock.h>
#include <bt_sock.h>

class Cdiscover: public CCheckedActive, public Mlog_base_impl
{
public:
	~Cdiscover();
	
	const TDesC& get_value();
	
	static Cdiscover* NewL(MApp_context& Context);
private:
	void ConstructL();
	Cdiscover(MApp_context& Context);
	virtual void DoCancel();
	virtual void CheckedRunL();
private:
	enum comm_state { IDLE, FIRST_SEARCH, NEXT_SEARCH };
	comm_state current_state;
	TBuf<1024> names;
	TBuf<1024> prev_env;

	RHostResolver hr;
	RSocket socket;
	RSocketServ socket_server;
	TInquirySockAddr addr;
	TNameEntry name;
	TProtocolDesc pInfo;
	RTimer timer;

	void release();
	void finished();
	
public:

};

#endif