// Mlogger.h: interface for the Mlogger class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_I_LOGGER_H__3E3A2582_93BF_4024_ABEC_8399BB61A5B5__INCLUDED_)
#define AFX_I_LOGGER_H__3E3A2582_93BF_4024_ABEC_8399BB61A5B5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "e32std.h"

_LIT(KLog_cellid, "area, cell, nw");
_LIT(KLog_profile, "profile");
_LIT(KLog_cellname, "base");
_LIT(KLog_location, "location");
_LIT(KLog_activity, "UserActivity");
_LIT(KLog_app, "app");

class Mlogger  
{
public:
	enum log_priority {
		INFO,
		DEBUG,
		VALUE,
		ERR
	};

	virtual void register_source(const TDesC& name, const TDesC& initial_value, const TTime& time) = 0;
	virtual void new_value(log_priority priority, const TDesC& name, const TDesC& value, const TTime& time) = 0;
	virtual void unregister_source(const TDesC& name, const TTime& time) = 0;
	virtual const TDesC& name() const = 0;
	Mlogger() { };
	virtual ~Mlogger() { };

};

#endif // !defined(AFX_I_LOGGER_H__3E3A2582_93BF_4024_ABEC_8399BB61A5B5__INCLUDED_)
