#ifndef LOG_BASE_IMPL_H_INCLUDED

#define LOG_BASE_IMPL_H_INCLUDED

#include "i_log_source.h"
#include <e32base.h>
#include <f32file.h>
#include "i_logger.h"
#include "app_context.h"

class Mlog_base_impl : public i_log_source, public MContextBase {
public:
	void add_sinkL(Mlogger* sink);
	void add_sinkL(Mlogger* sink, const TTime& time);
	void release_sinks();
	const TDesC& get_name();
	const TDesC& get_value();
	virtual void ConstructL(const TDesC& name, const TDesC& format);
	Mlog_base_impl(MApp_context& Context);
	~Mlog_base_impl();
	void post_new_value(const TDesC& value, Mlogger::log_priority priority=Mlogger::VALUE);
	void post_new_value(const TDesC& value, const TTime& time, Mlogger::log_priority priority=Mlogger::VALUE);
protected:
	HBufC* log_name;
	HBufC* log_format;
	CArrayFixFlat<Mlogger*>* loggers;
private:
	RFile debug;
};

class Clog_base_impl : public Mlog_base_impl, public CBase {
public:
	Clog_base_impl(MApp_context& Context);
	static Clog_base_impl* NewL(MApp_context& Context, const TDesC& name, const TDesC& format);
};

#endif
