#if !defined(LOG_COMM_H_INCLUDED)

#define LOG_COMM_H_INCLUDED 1

#include <logcli.h>
#include <e32base.h>
#include <f32file.h>
#include <logview.h>

#include "file_output_base.h"
#include "status_notif.h"
#include "app_context.h"

class Clog_comm: public CCheckedActive, public Mfile_output_base
{
public:
	~Clog_comm();
	
	TPtr get_value();
	
	static Clog_comm* NewL(MApp_context& Context, i_status_notif* callback);

	bool write_comm_log(); // true when starting to write, false if already writing
	bool write_comm_log(TTime from); // true when starting to write, false if already writing
	bool LogsExist(TTime& From);
private:
	virtual void DoCancel();
	virtual void CheckedRunL();
private:
	Clog_comm(MApp_context& Context);
	void ConstructL(i_status_notif* callback);

	enum comm_state { IDLE, WAITING_ON_FILTER, WAITING_ON_MOVE };
	comm_state current_state;
	CLogClient* logclient;
	CLogFilter* filter;
	CLogViewEvent* view;

	i_status_notif* cb;
	TTime	iFromTime;
	void finished();
	void write_event(const CLogEvent& ev);
};

#endif
