#if !defined(LOG_TEST_H_INCLUDED)

#define LOG_TEST_H_INCLUDED

#include <e32base.h>
#include <MdaAudioSampleEditor.h>
#include <f32file.h>

class log_test : public CTimer, public MMdaObjectStateChangeObserver {
public:
	log_test();
	~log_test();

	void CheckedRunL();

	void ConstructL();
	void MoscoStateChangeEvent(CBase* /*aObject*/, TInt /*aPreviousState*/, TInt /*aCurrentState*/, TInt /*aErrorCode*/);
private:
	CMdaServer* audio_server;
	CMdaAudioRecorderUtility* recorder_util;
	
	enum state { IDLE, OPENING, STARTING_RECORD, RECORDING, STOPPING };
	state current_state;
	void stop(bool reset=false);
	void open();
	void record();
	void calculate();
	void set_timer(TInt seconds);

	TMdaWavClipFormat format;
	TMdaPcmWavCodec codec; 
	TMdaAudioDataSettings args;

	TBuf8<2*2*8000> buf;
	TMdaDesClipLocation clip;
	RFs sess;
	RFile file;

};

#endif
