#ifndef STATUSVIEW_H_INCLUDED
#define STATUSVIEW_H_INCLUDED 1

#include <aknview.h>
#include "app_context.h"
#include "context_logcontainer.h"
#include "cellmap.h"

// CONSTANTS
// UID of view
const TUid KStatusViewId = {1};

class CStatusView : public CAknView, public MContextBase
    {
    public: // Constructors and destructor
	static CStatusView* NewL(MApp_context& Context, CCellMap& CellMap);

        ~CStatusView();
	CContext_logContainer* Container() { return iContainer; }

    public: 
        
        TUid Id() const;
        void HandleCommandL(TInt aCommand);
        void HandleClientRectChange();

    private:
	CStatusView(MApp_context& Context) : MContextBase(Context) { }
        void ConstructL(CCellMap& CellMap);

        void DoActivateL(const TVwsViewId& aPrevViewId,TUid aCustomMessageId,
            const TDesC8& aCustomMessage);
        void DoDeactivate();
	void DynInitMenuPaneL(
			 TInt aResourceId,CEikMenuPane* aMenuPane);
	
    private: // Data
        CContext_logContainer* iContainer;
	TUid id;
	bool iActive;
    };

#endif
