#include "userview.h"
#include "symbian_auto_ptr.h"
#include "context_log.rsg"
#include "context_log.hrh"
#include <aknviewappui.h> 
#include <eiktxlbm.h>
#include <akntitle.h> 
#include <avkon.mbg>
#include <contextbook.mbg>

#include <gulbordr.h>
#include <gulicon.h>

#include "app_context.h"

// ================= MEMBER FUNCTIONS =======================

CUserContextContainer::CUserContextContainer()
{
	CALLSTACKITEM(_L("CUserContextContainer::CUserContextContainer"));

}

void CUserContextContainer::ConstructL(const TRect& aRect, CCircularLog* Log, MEikListBoxObserver* ListBoxObserver)
{
	CALLSTACKITEM(_L("CUserContextContainer::ConstructL"));

	iLog=Log;
	
	iLog->SetObserver(this);

	CreateWindowL(); 

	//iListBox = new (ELeave) CEikTextListBox;
	iListBox = new (ELeave) doublelinebox;
	iListBox->SetMopParent(this);
	iListBox->ConstructL(this, EAknListBoxSelectionList);


	iListBox->SetItemHeightL(40);
	iListBox->View()->SetMatcherCursor(EFalse);
	
	// icon array
	CArrayPtr<CGulIcon> * icons = new (ELeave) CArrayPtrFlat<CGulIcon>(15);

	//0 - empty Icon
	icons->AppendL(iEikonEnv->CreateIconL(_L("Z:\\system\\data\\avkon.mbm"), 
			EMbmAvkonQgn_stat_bt_blank, 
			EMbmAvkonQgn_stat_bt_blank +1));
	
	TBuf<128> KMbmFile;
#ifndef __WINS__
	KMbmFile=_L("c:\\system\\apps\\CONTEXTBOOK\\contextbook.mbm");
#else
	KMbmFile=_L("z:\\system\\apps\\CONTEXTBOOK\\contextbook.mbm");
#endif
	//1 - speaker ON
	icons->AppendL(iEikonEnv->CreateIconL(KMbmFile, 
			EMbmContextbookSpeaker_on,
			EMbmContextbookSpeaker_on_mask));

	//2 - speaker OFF
	icons->AppendL(iEikonEnv->CreateIconL(KMbmFile, 
			EMbmContextbookSpeaker_off, 
			EMbmContextbookSpeaker_off_mask));

	//3 - speaker ON grey
	icons->AppendL(iEikonEnv->CreateIconL(KMbmFile, 
			EMbmContextbookSpeaker_on_grey, 
			EMbmContextbookSpeaker_on_grey_mask));

	//4 - speaker OFF grey
	icons->AppendL(iEikonEnv->CreateIconL(KMbmFile, 
			EMbmContextbookSpeaker_off_grey, 
			EMbmContextbookSpeaker_off_grey_mask));

	//5 - user active
	icons->AppendL(iEikonEnv->CreateIconL(KMbmFile, 
			EMbmContextbookUser_active, 
			EMbmContextbookUser_active_mask));

	//6 - user inactive 
	icons->AppendL(iEikonEnv->CreateIconL(KMbmFile, 
			EMbmContextbookUser_inactive, 
			EMbmContextbookUser_inactive_mask));
	
	//7 - vibrator ON
	icons->AppendL(iEikonEnv->CreateIconL(KMbmFile, 
			EMbmContextbookVibrator_on, 
			EMbmContextbookVibrator_on_mask));
	
	//8 - vibrator OFF 
	icons->AppendL(iEikonEnv->CreateIconL(KMbmFile, 
			EMbmContextbookVibrator_off,
			EMbmContextbookVibrator_off_mask));

	//9 - vibrator ON grey
	icons->AppendL(iEikonEnv->CreateIconL(KMbmFile, 
			EMbmContextbookVibrator_on_grey,
			EMbmContextbookVibrator_on_grey_mask));

	//10 - vibrator OFF grey
	icons->AppendL(iEikonEnv->CreateIconL(KMbmFile, 
			EMbmContextbookVibrator_off_grey,
			EMbmContextbookVibrator_off_grey_mask));

	//11 - user_inactive level 1
	icons->AppendL(iEikonEnv->CreateIconL(KMbmFile, 
			EMbmContextbookUser_inactive_lvl_1,
			EMbmContextbookUser_inactive_mask));

	//12 - user_inactive level 2
	icons->AppendL(iEikonEnv->CreateIconL(KMbmFile, 
			EMbmContextbookUser_inactive_lvl_2,
			EMbmContextbookUser_inactive_mask));

	//13 - user_inactive level 3
	icons->AppendL(iEikonEnv->CreateIconL(KMbmFile, 
			EMbmContextbookUser_inactive_lvl_3,
			EMbmContextbookUser_inactive_mask));


	iListBox->ItemDrawer()->FormattedCellData()->SetIconArray(icons);

	iListBox->Model()->SetItemTextArray(iLog);
	iListBox->Model()->SetOwnershipType(ELbmDoesNotOwnItemArray);
	iListBox->CreateScrollBarFrameL(ETrue);
	iListBox->ScrollBarFrame()->SetScrollBarVisibilityL( CEikScrollBarFrame::EOff, CEikScrollBarFrame::EAuto);

	iListBox->MakeVisible(ETrue);
	iListBox->SetRect(aRect);
	iListBox->ActivateL();
	iListBox->DrawNow();

	iListBox->SetListBoxObserver(ListBoxObserver);

	SetRect(aRect);
	ActivateL();
}
CUserContextContainer::~CUserContextContainer()
{
	CALLSTACKITEM(_L("CUserContextContainer::~CUserContextContainer"));

	iLog->SetObserver(0);
	delete iListBox;
	
}
void CUserContextContainer::SizeChanged()
{
	CALLSTACKITEM(_L("CUserContextContainer::SizeChanged"));

	iListBox->SetRect(Rect());
}

TInt CUserContextContainer::CountComponentControls() const
{
	CALLSTACKITEM(_L("CUserContextContainer::CountComponentControls"));

	return 1;
}

CCoeControl* CUserContextContainer::ComponentControl(TInt aIndex) const
{
	CALLSTACKITEM(_L("CUserContextContainer::ComponentControl"));

	if (aIndex==0) return iListBox;
	return 0;
}

void CUserContextContainer::Draw(const TRect& aRect) const
{
	CALLSTACKITEM(_L("CUserContextContainer::Draw"));

	CWindowGc& gc = SystemGc();
	// TODO: Add your drawing code here
	// example code...
	gc.SetPenStyle(CGraphicsContext::ENullPen);
	gc.SetBrushColor(KRgbWhite);
	gc.SetBrushStyle(CGraphicsContext::ESolidBrush);
	gc.DrawRect(aRect);

	
}

void CUserContextContainer::HandleControlEventL(
						CCoeControl* /*aControl*/,TCoeEvent /*aEventType*/)
{
	CALLSTACKITEM(_L("CUserContextContainer::HandleControlEventL"));

	// TODO: Add your control event handler code here
}

void CUserContextContainer::ContentsChanged()
{
	CALLSTACKITEM(_L("CUserContextContainer::ContentsChanged"));

	TRAPD(err,
		if (iListBox) iListBox->HandleItemRemovalL();
		iListBox->DrawNow());
}

TKeyResponse CUserContextContainer::OfferKeyEventL(const TKeyEvent &aKeyEvent, TEventCode aType)
{
	CALLSTACKITEM(_L("CUserContextContainer::OfferKeyEventL"));

	return iListBox->OfferKeyEventL(aKeyEvent, aType);
}

CUserView* CUserView::NewL(CCircularLog* Log)
{
	CALLSTACKITEM(_L("CUserView::NewL"));

	auto_ptr<CUserView> ret(new (ELeave) CUserView);
	ret->ConstructL(Log);
	return ret.release();
}

CUserView::CUserView()
{
	CALLSTACKITEM(_L("CUserView::CUserView"));

}

// ---------------------------------------------------------
// CAppLogView::ConstructL(const TRect& aRect)
// EPOC two-phased constructor
// ---------------------------------------------------------
//
void CUserView::ConstructL(CCircularLog* Log)
{
	CALLSTACKITEM(_L("CUserView::ConstructL"));

	BaseConstructL( R_USERVIEW_VIEW );
	iLog=Log;
	
	
}


// ---------------------------------------------------------
// CAppLogView::~CAppLogView()
// ?implementation_description
// ---------------------------------------------------------
//
CUserView::~CUserView()
{
	CALLSTACKITEM(_L("CUserView::~CUserView"));

	if ( iContainer )
        {
		AppUi()->RemoveFromViewStack( *this, iContainer );
        }
	
	delete iContainer;
}

// ---------------------------------------------------------
// TUid CAppLogView::Id()
// ?implementation_description
// ---------------------------------------------------------
//
TUid CUserView::Id() const
{
	CALLSTACKITEM(_L("CUserView::Id"));

	return KUserViewId;
}

// ---------------------------------------------------------
// CAppLogView::HandleCommandL(TInt aCommand)
// ?implementation_description
// ---------------------------------------------------------
//
void CUserView::HandleCommandL(TInt aCommand)
{   
	CALLSTACKITEM(_L("CUserView::HandleCommandL"));

	switch ( aCommand )
        {
       // case EAknSoftkeyClose:
		//	AppUi()->HandleCommandL( Econtext_logCmdlogviewClose );
		//break;

		case EAknSoftkeyBack:
		AppUi()->HandleCommandL( EAknSoftkeyBack );
		break;
		

		case Econtext_logDetailedView:
			AppUi()->HandleCommandL( Econtext_logDetailedView );
			break;

        default:
		// TODO
		//AppUi()->HandleCommandL( Econtext_logCmdSettingsCancel );
		break;
        }
}

// ---------------------------------------------------------
// CAppLogView::HandleClientRectChange()
// ---------------------------------------------------------
//
void CUserView::HandleClientRectChange()
{
	CALLSTACKITEM(_L("CUserView::HandleClientRectChange"));

	if ( iContainer )
        {
		iContainer->SetRect( ClientRect() );
        }
}

// ---------------------------------------------------------
// CAppLogView::DoActivateL(...)
// ?implementation_description
// ---------------------------------------------------------
//
void CUserView::DoActivateL(
				const TVwsViewId& /*aPrevViewId*/,TUid /*aCustomMessageId*/,
				const TDesC8& /*aCustomMessage*/)
{
	CALLSTACKITEM(_L("CUserView::DoActivateL"));

	if (!iContainer) {
		iContainer=new (ELeave) CUserContextContainer;
		iContainer->SetMopParent(this);
		iContainer->ConstructL( ClientRect(), iLog, this);
		AppUi()->AddToStackL( *this, iContainer );
        } 
}

// ---------------------------------------------------------
// CAppLogView::HandleCommandL(TInt aCommand)
// ?implementation_description
// ---------------------------------------------------------
//
void CUserView::DoDeactivate()
{
	CALLSTACKITEM(_L("CUserView::DoDeactivate"));

	if ( iContainer )
        {
		AppUi()->RemoveFromViewStack( *this, iContainer );
        }
	
	delete iContainer;
	iContainer = 0;
}

void CUserView::HandleListBoxEventL(CEikListBox* aListBox,TListBoxEvent aEventType)
{
	CALLSTACKITEM(_L("CUserView::HandleListBoxEventL"));

	/*if (aEventType== EEventEnterKeyPressed) {
		TInt idx=aListBox->CurrentItemIndex();
		TPtrC16 event=iLog->MdcaPoint(idx);
		auto_ptr<CAknMessageQueryDialog> note(CAknMessageQueryDialog::NewL(event));
		note.release()->ExecuteLD(R_LOGVIEW_EVENT_DIALOG);
	}*/
}

// End of File
