#ifndef CB_PRESENCE_H_INCLUDED
#define CB_PRESENCE_H_INCLUDED 1

#include "symbian_tree.h"
#include "list.h"
#include "jabberdata.h"
#include "presence_data.h"
#include "contextclientsession.h"
#include "timeout.h"


class MPresenceListener {
public:
	virtual void PresenceChangedL(TInt ContactId, const CPresenceData& Info) = 0;
	virtual void Notify(const TDesC & aMessage) = 0;
};

class CPresenceHolder : public CCheckedActive, public MTimeOut {
public:
	static CPresenceHolder* NewL(CJabberData& JabberData);
	~CPresenceHolder();

	void AddListener(MPresenceListener* Listener);
	const CPresenceData* const GetPresence(TInt ContactId) const;

	void CancelRequest();
	void NewPresence(const TDesC& Nick, const TDesC& Info, const TTime& send_timestamp);
	CPresenceData* GetPresence(TInt ContactId);

protected: // from CCheckedActive
	void CheckedRunL();
	void DoCancel();

private:
	CPresenceHolder(CJabberData& JabberData);
	void ConstructL();

	static void CPresenceDataDeletor(void* p);

	CJabberData&			iJabberData;
	CGenericIntMap*			iPresenceData;
	CList<MPresenceListener*>*	iListeners;

private:
	void Start();
	void Restart();
	void expired();
	void RequestPresence();
	void RequestPresenceNotification();

	

	enum TState
	{
      		EIdle,
        	EWaitingForPresence		
	};

	TState current_state;

	RContextClientSession  		iSession;
	
	HBufC * 			iContact;
	HBufC *				iPresence;
	TPtr				iC;
	TPtr				iP;
	bool				iSessionOpen;
	CTimeOut*			iWait;
	TTime				iSendTimeStamp;
	const static TInt KDefaultBufferSize;

};

#endif