/*
* ============================================================================
*  Name     : CContextbookAppUi from ContextbookAppUi.cpp
*  Part of  : contextbook
*  Created  : 14.7.2003 by 
*  Implementation notes:
*     Initial content was generated by Series 60 AppWizard.
*  Version  :
*  Copyright: 
* ============================================================================
*/

// INCLUDE FILES
#include "ContextbookAppUi.h"
#include "ContextbookView.h"
#include "ContextbookView2.h"
#include <contextbook.rsg>
#include "contextbook.hrh"
#include <eikmenup.h>
#include <avkon.hrh>
#include "db.h"
#include <RPbkViewResourceFile.h>
#include <CPbkContactEditorDlg.h>
#include <CPbkContactEngine.h>
#include <CPbkSelectFieldDlg.h>
#include <CPbkContactItem.h>

#include <eikspane.h> 
#include <eiklabel.h>
#include <aknindicatorcontainer.h> 

#include <aknEditStateIndicator.h>
#include <logwrap.h>
#include <logcli.h>

#include <aknenv.h> 

_LIT(KTestPresence, "<presence><event><datetime>20040428T195102 </datetime><location><location.value><location.network>RADIOLINJA</location.network><location.lac>9006</location.lac><location.cellid>18</location.cellid></location.value></location></event><event><datetime>20040428T195102 </datetime><base><base.current>ESTI1</base.current></base></event><event><datetime>20040428T195057 </datetime><useractivity><useractivity.value>active</useractivity.value></useractivity></event><event><datetime>20040428T195057 </datetime><profile><profile.value><profile.id>0</profile.id><profile.name>General</profile.name></profile.value></profile></event></presence>");

// ================= MEMBER FUNCTIONS =======================
//
// ----------------------------------------------------------
// CContextbookAppUi::ConstructL()
// ?implementation_description
// ----------------------------------------------------------
//
void CContextbookAppUi::ConstructL()
{
	BaseConstructL();

	/*CLogClient * logClient = CLogClient::NewL(CEikonEnv::Static()->FsSession());

	CLogEvent * event = CLogEvent::NewL();
	event->SetContact(1);
	event->SetDirection(_L("Outgoing"));
	event->SetEventType(KLogCallEventTypeUid);
	TTime now; 
	now.HomeTime();
	event->SetTime(now);
	event->SetRemoteParty(_L("test"));
	TRequestStatus aStatus;
	logClient->AddEvent(*event, aStatus);

*/

	iLog=Cfile_output_base::NewL(AppContext(), _L("book_log"));

	iCaptionBook=CEikonEnv::Static()->AllocReadResourceL(R_CB_BOOK_CAPTION);
	iCaptionLog=CEikonEnv::Static()->AllocReadResourceL(R_CB_LOG_CAPTION);

	iJabberDb=CDb::NewL(AppContext(), _L("JABBER"), EFileWrite|EFileShareAny);
	iJabberData=CJabberData::NewL(AppContext(), *iJabberDb);

	iPresenceHolder=CPresenceHolder::NewL(*iJabberData);

	book=new (ELeave) phonebook(AppContext(), *iJabberData, *iPresenceHolder);
	book->ConstructL();
	iPresenceHolder->AddListener(book);
	
	iPresenceHolder->AddListener(this);

	iPresenceUpdater = new (ELeave) CPresenceUpdater(*book);
	iPresenceUpdater->ConstructL();

	log=new (ELeave) call_log;
	log->ConstructL();
	
	view1 = new (ELeave) CContextbookView(*iJabberData, iLog);
	
	CleanupStack::PushL( view1 );
	view1->ConstructL(KViewId, book, true, *iCaptionBook);
	AddViewL( view1 );      // transfer ownership to CAknViewAppUi
	CleanupStack::Pop();    // view1
	
	view2 = new (ELeave) CContextbookView(*iJabberData, iLog);
	
	CleanupStack::PushL( view2 );
	view2->ConstructL(KView2Id, log, false, *iCaptionLog);
	AddViewL( view2 );      // transfer ownership to CAknViewAppUi
	CleanupStack::Pop();    // view2

	SetDefaultViewL(*view1);
	//SetDefaultViewL(*view2);

	iEikonEnv->AddForegroundObserverL(*this);

}

// ----------------------------------------------------
// CContextbookAppUi::~CContextbookAppUi()
// Destructor
// Frees reserved resources
// ----------------------------------------------------
//
CContextbookAppUi::~CContextbookAppUi()
{
	iEikonEnv->RemoveForegroundObserver(*this);

	delete iLog;

	delete book;
	delete log;
	delete iPresenceHolder;
	delete iPresenceUpdater;
	delete iJabberData;
	delete iJabberDb;

	delete iCaptionBook;
	delete iCaptionLog;
}

// ------------------------------------------------------------------------------
// CContextbookAppUi::::DynInitMenuPaneL(TInt aResourceId,CEikMenuPane* aMenuPane)
//  This function is called by the EIKON framework just before it displays
//  a menu pane. Its default implementation is empty, and by overriding it,
//  the application can set the state of menu items dynamically according
//  to the state of application data.
// ------------------------------------------------------------------------------
//
void CContextbookAppUi::DynInitMenuPaneL( TInt /*aResourceId*/,
					  CEikMenuPane* /*aMenuPane*/)
{
	

}

// ----------------------------------------------------
// CContextbookAppUi::HandleKeyEventL(
//     const TKeyEvent& aKeyEvent,TEventCode /*aType*/)
// ?implementation_description
// ----------------------------------------------------
//
TKeyResponse CContextbookAppUi::HandleKeyEventL(
						const TKeyEvent& aKeyEvent,TEventCode /*aType*/)
{
	return EKeyWasNotConsumed;
}

// ----------------------------------------------------
// CContextbookAppUi::HandleCommandL(TInt aCommand)
// ?implementation_description
// ----------------------------------------------------
//
void CContextbookAppUi::HandleCommandL(TInt aCommand)
{
	
	
	switch ( aCommand )
        {
        case EEikCmdExit:
		Exit();
		break;
        
		case EAknSoftkeyBack:
		hide();
		break;
	case EcontextbookCmdLog:
		log->refresh();
		ActivateLocalViewL(KView2Id);
		break;

	case EcontextbookCmdBook:
		ActivateLocalViewL(KViewId);
		break;
	case EcontextbookCmdPresenceTest:
		{
			TTime now;
			now.HomeTime();
		iPresenceHolder->NewPresence(_L("mikie@jabber.org"), KTestPresence, now);
		break;
		}
	case EcontextbookCmdEditor:
		{
			ShowEditor(true);
			break;
		}
	case EcontextbookCmdCreate:
		{
			ShowEditor(false);
			break;
		}
        default:
		break;      
        }
}

class CTestTimer : public CTimer
{
public:
	CTestTimer() : CTimer(EPriorityNormal) { }
	void ConstructL() { 
		CTimer::ConstructL(); 
		CActiveScheduler::Add(this);
		After(TTimeIntervalMicroSeconds32(200*1000));
	}
	void CheckedRunL() {
		After(TTimeIntervalMicroSeconds32(200*1000));
		RDebug::Print(_L("timer!"));
	}
	~CTestTimer() {
		Cancel();
	}
private:
};

void CContextbookAppUi::ShowEditor(bool existing)
{
	CCoeEnv *env = CEikonEnv::Static();
	RPbkViewResourceFile pbkRes( *env);
	pbkRes.OpenL();
	CleanupClosePushL(pbkRes);

	CPbkContactEngine *ipPabEng=book->get_engine();

	CPbkContactItem* aContactItem=0;
	TBool create_new;
	if (existing) {
		aContactItem= ipPabEng->OpenContactLCX ( book->GetContactId( view1->GetCurrentIdx() ) );
		create_new=EFalse;
	} else {
		aContactItem=ipPabEng->CreateEmptyContactL();
		CleanupStack::PushL(aContactItem);
		create_new=ETrue;
	}

	// launch the contacts dialog
	CPbkContactEditorDlg *ipPabDlg =
	CPbkContactEditorDlg::NewL(*ipPabEng, *aContactItem, create_new);

	ipPabDlg->SetMopParent( this );

	TInt res = KErrNone;
	
	TRAPD( err, res = ipPabDlg->ExecuteLD());

	if (existing) {
		CleanupStack::PopAndDestroy(3); //pbkRes, aContactItem, contact lock
	} else {
		CleanupStack::PopAndDestroy(2); //pbkRes, aContactItem
	}
}

void CContextbookAppUi::hide()
{
	RWsSession& wsSession=CEikonEnv::Static()->WsSession();
	
	TApaTask task(wsSession);
	task.SetWgId(CEikonEnv::Static()->RootWin().Identifier());
	task.SendToBackground();
}

void CContextbookAppUi::HandleGainingForeground()
{
	iLog->write_time();
	iLog->write_to_output(_L("To foreground"));
	iLog->write_nl();
	
	log->refresh();
	
	iPresenceUpdater->Start();
}

void CContextbookAppUi::HandleLosingForeground()
{
	iLog->write_time();
	iLog->write_to_output(_L("To background\n"));
	iLog->write_nl();
	iPresenceUpdater->Stop();
}

void CContextbookAppUi::Notify(const TDesC& aMessage)
{
	//CAknIndicatorContainer * ic = CAknEnv::Static()->EditingStateIndicator()->IndicatorContainer();

	//CAknIndicator c = CAknIndicator();

	//ic->CAknNavigationControlContainer* iNaviPane = (CAknNavigationControlContainer*)ic->ControlL(TUid::Uid(EEikStatusPaneUidNavi));
	//ic->SetIndicatorState();
	//CEikStatusPane* sp = StatusPane();
	//CAknNavigationControlContainer* iNaviPane = (CAknNavigationControlContainer*)sp->ControlL(TUid::Uid(EEikStatusPaneUidNavi));
	//CAknNavigationDecorator* deco = iNaviPane->CreateNavigationLabelL(_L("test"));
	
	//iNaviPane->PushL( *deco  );

	//CEikonEnv::Static()->InfoMsg(_L("test"));

	//if (iEikonEnv->IsBusy())
	//{
		iEikonEnv->BusyMsgCancel();
	//}
	if (aMessage.Compare(_L("")) != 0 )
	{
		iEikonEnv->BusyMsgL(aMessage,TGulAlignment(EHRightVTop));
	}
		//CEikonEnv::Static()->InfoMsgWithAlignment();
}

void CContextbookAppUi::PresenceChangedL(TInt ContactId, const CPresenceData &info)
{
	// no implementation
}



// End of File  
