/*
* ============================================================================
*  Name     : CContextbookView from ContextbookView.h
*  Part of  : contextbook
*  Created  : 14.7.2003 by 
*  Implementation notes:
*     Initial content was generated by Series 60 AppWizard.
*  Version  :
*  Copyright: 
* ============================================================================
*/

// INCLUDE FILES
#include  <aknviewappui.h>
#include  <avkon.hrh>
#include  <contextbook.rsg>
#include  "ContextbookView.h"
#include  "ContextbookContainer.h" 
#include  "Contextbook.hrh"
#include <aknquerydialog.h> 
#include <RPbkViewResourceFile.h>
#include <CPbkContactEditorDlg.h>
#include <CPbkContactEngine.h>
#include <CPbkSelectFieldDlg.h>
#include <CPbkContactItem.h>
#include "nickform.h"
#include <aknnavi.h>
#include <akntitle.h> 
#include <eikenv.h>


// ================= MEMBER FUNCTIONS =======================

/*
	if (id==KViewId) {
		aMenuPane->SetItemDimmed(EcontextbookCmdBook, ETrue);	
		aMenuPane->SetItemDimmed(EcontextbookCmdLog, EFalse);	
	} else {
		aMenuPane->SetItemDimmed(EcontextbookCmdBook, EFalse);	
		aMenuPane->SetItemDimmed(EcontextbookCmdLog, ETrue);
	}
*/

// ---------------------------------------------------------
// CContextbookView::ConstructL(const TRect& aRect)
// EPOC two-phased constructor
// ---------------------------------------------------------
//




//-------------
void CContextbookView::ConstructL(TUid i_id, phonebook_i* i_book, bool i_searchable, const TDesC& i_title)
{
	
	if (i_id==KViewId) 
	{
		BaseConstructL( R_CONTEXTBOOK_VIEW1 );
	}
	else
	{
		BaseConstructL( R_CONTEXTBOOK_VIEW2 );
	}
	id=i_id;
	book=i_book;
	searchable=i_searchable;
	title=i_title;
	
}

// ---------------------------------------------------------
// CContextbookView::~CContextbookView()
// ?implementation_description
// ---------------------------------------------------------
//
CContextbookView::~CContextbookView()
{
	if ( iContainer )
        {
		AppUi()->RemoveFromViewStack( *this, iContainer );
        }
	
	delete iContainer;
	
}

// ---------------------------------------------------------
// TUid CContextbookView::Id()
// ?implementation_description
// ---------------------------------------------------------
//
TUid CContextbookView::Id() const
{
	return id;
}

// ---------------------------------------------------------
// CContextbookView::HandleCommandL(TInt aCommand)
// ?implementation_description
// ---------------------------------------------------------
//
void CContextbookView::HandleCommandL(TInt aCommand)
{   
	switch ( aCommand )
        {
        case EAknSoftkeyBack:
		{
			AppUi()->HandleCommandL(EAknSoftkeyBack);
			break;
		}
	case EcontextbookCmdSMS:
		{
			iContainer->sms_current();
			//iLog->write_time();
			//iLog->write_to_output(_L("Cmd SendSMS"));
			//iLog->write_nl();
			break;
		}
	case EcontextbookCmdNick:
		{
			iLog->write_time();
			iLog->write_to_output(_L("Cmd SetNick"));
			iLog->write_nl();
			set_nick();
			break;
		}
	case EcontextbookCmdCall:
		{
			//iLog->write_time();
			//iLog->write_to_output(_L("Cmd Call"));
			//iLog->write_nl();
			iContainer->call_current();
			break;
		}
        default:
		{
			AppUi()->HandleCommandL( aCommand );
			break;
		}
        }
}

void CContextbookView::set_nick()
{

	TInt idx=iContainer->get_current_idx();
	TInt contact=book->GetContactId(idx);

	CNickForm* f=CNickForm::NewL(iJabberData, contact, book->get_array()->MdcaPoint(idx), book);
	f->ExecuteLD();
}

// ---------------------------------------------------------
// CContextbookView::HandleClientRectChange()
// ---------------------------------------------------------
//
void CContextbookView::HandleClientRectChange()
{
	if ( iContainer )
        {
		iContainer->SetRect( ClientRect() );
        }
}

TInt CContextbookView::GetCurrentIdx()
{
	return iContainer->get_current_idx();
}

// ---------------------------------------------------------
// CContextbookView::DoActivateL(...)
// ?implementation_description
// ---------------------------------------------------------
//
void CContextbookView::DoActivateL(
				   const TVwsViewId& /*aPrevViewId*/,TUid /*aCustomMessageId*/,
				   const TDesC8& /*aCustomMessage*/)
{
	if (!iContainer)
        {
		iContainer = create_container();
		iContainer->SetMopParent(this);
		iContainer->ConstructL( ClientRect(), book, searchable, title, iLog );
		
	}
	iContainer->MakeVisible(ETrue);
	/*
	//Log here
	iLog->write_time();
	
	iLog->write_to_output(_L("Showing "));
	iLog->write_to_output(title);
	iLog->write_nl();
	*/
	AppUi()->AddToStackL( *this, iContainer );

}

// ---------------------------------------------------------
// CContextbookView::HandleCommandL(TInt aCommand)
// ?implementation_description
// ---------------------------------------------------------
//
void CContextbookView::DoDeactivate()
{
	if ( iContainer )
        {
		AppUi()->RemoveFromViewStack( *this, iContainer );
		iContainer->MakeVisible(EFalse);
		delete iContainer;
		iContainer=0;
        }
	
}

CContextbookContainer* CContextbookView::create_container()
{
	return new (ELeave) CContextbookContainer;
}



// End of File

