#include "nickform.h"
#include "symbian_auto_ptr.h"
#include "contextbook.rsg"
#include <avkon.hrh>
#include <eikedwin.h>
#include <eiklabel.h>

CNickForm* CNickForm::NewL(CJabberData& Data, TInt ContactId, const TDesC& Title, phonebook_i* Book)
{
	auto_ptr<CNickForm> self (
		new (ELeave) CNickForm(Data, ContactId, Book));
	self->ConstructL(Title);
	return self.release();
}

CNickForm::~CNickForm()
{
	delete iTitle;
}
CNickForm::CNickForm(CJabberData& Data, TInt ContactId, phonebook_i* Book) : 
	iData(Data), iContactId(ContactId), iBook(Book)
{
}

void CNickForm::ConstructL(const TDesC& Title)
{
	iTitle=Title.AllocL();
	iData.GetJabberNickL(iContactId, iNick);
	CAknForm::ConstructL();
}

TInt CNickForm::ExecuteLD()
{
	return CAknForm::ExecuteLD(R_CB_NICK_DIALOG);
}
void CNickForm::PrepareLC()
{
	CAknForm::PrepareLC(R_CB_NICK_DIALOG);
}

TBool CNickForm::SaveFormDataL()
{
	GetEdwinText(iNick, 2);

	iData.SetJabberNickL(iContactId, iNick);

	if (iBook) iBook->ReRead();

	return true;
}

TBool CNickForm::OkToExitL( TInt aButtonId )
{
	if (aButtonId==EAknSoftkeyOk) {
		TRAPD(err, SaveFormDataL());
		if (err!=KErrNone) {
			//TODO: show error
		}
	}
	return true;
}

void CNickForm::DoNotSaveFormDataL()
{
}
void CNickForm::SetInitialCurrentLine()
{
	ActivateFirstPageL();
	TryChangeFocusToL(2);
}

void CNickForm::PostLayoutDynInitL()
{
	CEikEdwin* f=(CEikEdwin*)Control(2);
	f->SetTextL(&iNick);

	CEikEdwin* l=(CEikEdwin*)Control(1);
	l->SetTextL(&(*iTitle));

	CAknForm::PostLayoutDynInitL();
	// To Following line change the edit mode
	SetEditableL(ETrue);

	// The following line set to change status
	// This avoid back set form View status in the beginning 
	// Usually without change back do that, like when we start an empty Form.
	SetChangesPending(ETrue);

}

TBool CNickForm::QuerySaveChangesL()
{
	TBool isAnsYes(CAknForm::QuerySaveChangesL());
	
	if (isAnsYes)
        {
		SaveFormDataL();
        }
	else 
        {
		// Case that answer "No" to query.
		DoNotSaveFormDataL();
        }
	
	return isAnsYes;
}